Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.encog.neural.neat.training
Class NEATInnovationList

    java.lang.Object
      org.encog.ml.genetic.innovation.BasicInnovationList
          org.encog.neural.neat.training.NEATInnovationList

All Implemented Interfaces:
  Serializable, InnovationList

    public class NEATInnovationList

extends BasicInnovationList
implements Serializable

Implements a NEAT innovation list. NeuroEvolution of Augmenting Topologies (NEAT) is a genetic algorithm for the generation of evolving artificial neural networks. It was developed by Ken Stanley while at The University of Texas at Austin. http://www.cs.ucf.edu/~kstanley/

See Also:
  Serialized Form

Constructor Summary
`NEATInnovationList()` The default constructor, used mainly for persistance.
`NEATInnovationList(Population population, Chromosome links, Chromosome neurons)` Construct an innovation list.

Method Summary
`NEATInnovation` | `checkInnovation(long in, long out, NEATInnovationType type)` Check to see if we already have an innovation.
`NEATNeuronGene` | `createNeuronFromID(long neuronID)` Create a new neuron gene from an id.
`void` | `createNewInnovation(long in, long out, NEATInnovationType type)` Create a new innovation.
`long` | `createNewInnovation(long from, long to, NEATInnovationType innovationType, NEATNeuronType neuronType, double x, double y)` Create a new innovation.
`void` | `setPopulation(NEATPopulation population)`

Methods inherited from class org.encog.ml.genetic.innovation.BasicInnovationList
`add, get, getInnovations`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NEATInnovationList

    public NEATInnovationList()

  The default constructor, used mainly for persistance.

### NEATInnovationList

    public NEATInnovationList(Population population,
                              Chromosome links,
                              Chromosome neurons)

  Construct an innovation list.

  Parameters:
    `population` - The population.
    `links` - The links.
    `neurons` - THe neurons.

Method Detail

### checkInnovation

    public NEATInnovation checkInnovation(long in,
                                          long out,
                                          NEATInnovationType type)

  Check to see if we already have an innovation.

  Parameters:
    `in` - The input neuron.
    `out` - THe output neuron.
    `type` - The type.
  Returns:
    The innovation, either new or existing if found.

### createNeuronFromID

    public NEATNeuronGene createNeuronFromID(long neuronID)

  Create a new neuron gene from an id.

  Parameters:
    `neuronID` - The neuron id.
  Returns:
    The neuron gene.

### createNewInnovation

    public void createNewInnovation(long in,
                                    long out,
                                    NEATInnovationType type)

  Create a new innovation.

  Parameters:
    `in` - The input neuron.
    `out` - The output neuron.
    `type` - The type.

### createNewInnovation

    public long createNewInnovation(long from,
                                    long to,
                                    NEATInnovationType innovationType,
                                    NEATNeuronType neuronType,
                                    double x,
                                    double y)

  Create a new innovation.

  Parameters:
    `from` - The from neuron.
    `to` - The to neuron.
    `innovationType` - THe innovation type.
    `neuronType` - The neuron type.
    `x` - The x-coordinate.
    `y` - The y-coordinate.
  Returns:
    The new innovation.

### setPopulation

    public void setPopulation(NEATPopulation population)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2011. All Rights Reserved.